﻿

// File Service.cpp

#include "Common.h"
#include "LanguageDef.h"

#include "service.h"




/*

Command:

	C:\Program Files\Microsoft Visual Studio 8\Common7\IDE\devenv.exe

Arguments:

	/rootsuffix Exp "C:\Documents and Settings\Computer\My Documents\ColourSyntaxTest\test.tst"


Post Build Step:

	"C:\Program Files\Visual Studio 2005 SDK\2007.02\VisualStudioIntegration\tools\bin\RegIt" /root:Software\Microsoft\VisualStudio\8.0Exp "$(TargetPath)"

Linker Properties:
	Module Definition File: dllmain.def



*/


/*---------------------------------------------------------
  Globals
---------------------------------------------------------*/

extern ITypeInfo*   g_typeInfoBabelService; // declared in dllmain.cpp


const wchar_t*  g_languageName              =   L"Test";
const wchar_t*  g_languageFileExtensions[]  = { L".tst",  NULL };
const CLSID     g_languageCLSID             = {0x82F0282F, 0xCDE5, 0x432B, { 0xA8, 0x31, 0xE5, 0x76, 0x5C, 0x13, 0xFF, 0x8A }};

const LanguageProperty g_languageProperties[] =
{
  { L"RequestStockColors", 0		},

  { L"ShowCompletion",     1		},
  { L"SortMemberList",     1		},

  { L"CodeSense",          1		},
  { L"CodeSenseDelay",     1500		},
  { L"MaxErrorMessages",   5		},
  { L"QuickInfo",          0		},
  { L"MatchBraces",        1		},
  { L"ShowMatchingBrace",  0		},
  { L"MatchBracesAtCaret", 0		},

  { NULL, 0 }
};



class MyService : public IBabelService
{
public:

	MyService()
	{
		m_refCount = 1;  
		IncRefCount( &g_dllRefCount );
	}

	~MyService()
	{
		DecRefCount( &g_dllRefCount );
	}



	STDMETHODIMP  ColorLine( in BSTR line, 
                                     in IColorSink* sink,
                                     inout long* state )
	{
		if (!state) return E_POINTER;
	 
		if (sink)
		{
			int len = (int)wcslen(line)-1;

			// ************************************
			// Colorize half the lines green!!
			// ************************************
			len = (int)(len * 0.5f);

			sink->Colorize( 0,						// long         startIdx
							len,					// long         endIdx
							ClassComment,			// ColorClass   colorClass
							CharText,				// CharClass    charClass
							TriggerNone );			// TriggerClass trigger
		}


		return S_OK;
	}

	STDMETHODIMP Init( in LCID lcid, in long reserved )	{return S_OK;}
	STDMETHODIMP Done()									{return S_OK;}
	STDMETHODIMP ColorCount(out ColorClass* count)		{return S_OK;}
	STDMETHODIMP GetColorInfo(in ColorClass index, 
							  out BSTR* description, 
							  out BSTR* style )			{return S_OK;}
	STDMETHODIMP ParseSource(in BSTR source,
                             in IParseSink* sink,
                             in ParseReason reason,
                             in long reserved,
                             out IScope** scope )		{return S_OK;}

	STDMETHODIMP GetMethodFormat(out BSTR* parStart, 
								 out BSTR* parSep, 
								 out BSTR* parEnd,
                                 out BSTR* typeStart, 
								 out BSTR* typeEnd,
                                 out VARIANT_BOOL* typePrefixed )
	{
		return E_NOTIMPL;
	}
	STDMETHODIMP GetCommentFormat( out BSTR* lineStart, 
                                   out BSTR* blockStart, 
								   out BSTR* blockEnd,
                                   out VARIANT_BOOL* useLineComments )
	{
		return E_NOTIMPL;
	}
	STDMETHODIMP GetImageList( out long* imageListHandle, 
							   out long* glyphCount )
	{
	   return E_NOTIMPL;
	}


	// ---------------------------------------------------------
    // IUnknown
	// -----------------------------------------------------------
	STDMETHODIMP QueryInterface( in REFIID iid, out void** obj )
	{
	  OUTARG(obj);

	  if (iid == IID_IUnknown)
	  {
		*obj = static_cast<IUnknown*>(this);
	  }
	  else if (iid == IID_IDispatch)
	  {
		*obj = static_cast<IDispatch*>(this);
	  }
	  else if (iid == IID_IBabelService)
	  {
		*obj = static_cast<IBabelService*>(this);
	  }
	  else
		return E_NOINTERFACE;

	  AddRef();
	  return S_OK;
	}

	STDMETHODIMP_(ULONG) AddRef()
	{
	  return IncRefCount(&m_refCount);
	}

	STDMETHODIMP_(ULONG) Release()
	{
	  if (DecRefCount(&m_refCount) == 0)
	  {
		delete this;
		return 0;
	  }
	  else
		return m_refCount;
	}

	//---------------------------------------------------------
	// implement IDispatch (for IBabelService only)
	//-----------------------------------------------------------
	STDMETHODIMP GetTypeInfoCount( out UINT* count )
	{
		
	  OUTARG(count);

	  if (g_typeInfoBabelService) *count = 1;
						  else *count = 0;
	  return S_OK;
	}

	STDMETHODIMP GetTypeInfo( in UINT index, in LCID lcid, out ITypeInfo** typeInfo )
	{
	  OUTARG(typeInfo);
	  if (index != 0) return E_INVALIDARG;
	  if (!g_typeInfoBabelService) return TYPE_E_CANTLOADLIBRARY;

	  *typeInfo = g_typeInfoBabelService;
	  return S_OK;
	}

	STDMETHODIMP GetIDsOfNames( in REFIID iid, in OLECHAR** names, in UINT count, 
										   in LCID lcid, out DISPID* dispids )
	{
	  if (!g_typeInfoBabelService) return TYPE_E_CANTLOADLIBRARY;
	  return g_typeInfoBabelService->GetIDsOfNames( names, count, dispids );
	}

	STDMETHODIMP Invoke( in DISPID dispid, in REFIID iid, in LCID lcid, 
									in WORD flags, in DISPPARAMS* args, 
									out VARIANT* result, out EXCEPINFO* error, out UINT* errorArg )
	{
	  if (!g_typeInfoBabelService) return TYPE_E_CANTLOADLIBRARY;  
	  return g_typeInfoBabelService->Invoke( static_cast<IBabelService*>(this), 
										  dispid, flags, args, result, error, errorArg );
	}
	  


	private:
	ULONG             m_refCount;
    ITypeInfo*        m_typeInfo;   //IBabelService typeinfo.
    

};


/*---------------------------------------------------------
  Create Service
---------------------------------------------------------*/
HRESULT CreateBabelService( out IBabelService** babelService )
{
  TRACE(L"CreateBabelService");
  OUTARG(babelService);

  *babelService = new MyService();
  if (*babelService == NULL) return E_OUTOFMEMORY;

  return S_OK;
}



